/* this code was lifted from linux/lib/vsprintf.c */
/* author- Feb 1 16:51:32 CET 2004 Juergen Quade <quade@hsnr.de> */
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

//#define likely(x) (x)
#define likely(x) __builtin_expect(!!(x), 1)

int vscnprintf(char *buf, size_t size, const char *fmt, va_list args)
{
    int i;

    i = vsnprintf(buf, size, fmt, args);

    if (likely(i < size))
        return i;
    if (size != 0)
        return size - 1;
    return 0;
}

int scnprintf(char *buf, size_t size, const char *fmt, ...)
{
    va_list args;
    int i;

    va_start(args, fmt);
    i = vscnprintf(buf, size, fmt, args);
    va_end(args);

    return i;
}

